#!/bin/bash
# Copyright 2007-2009, Kees Cook <kees@outflux.net> License: GPLv3
#
# On Debian/Ubuntu, make sure you have "ca-certificates" package installed.
#
# Notice the exit codes that openssl produces:

echo "Bad:"
echo "  openssl s_client -connect www.paypal.com:443"
echo "" | openssl s_client -connect www.paypal.com:443 2>/dev/null | grep Verify

echo ""

echo "Good:"
echo "  openssl s_client -CApath /etc/ssl/certs -connect www.paypal.com:443"
echo "" | openssl s_client -CApath /etc/ssl/certs -connect www.paypal.com:443 2>/dev/null | grep Verify
