// Copyright 2007-2009, Kees Cook <kees@outflux.net> License: GPLv3
/*
 * Run this with after a "ulimit -c unlimited" to allow core dumps.
 * Be sure to remove any other core files in the current directory first.
 *
 * After the crash, look for your password with:
 *  strings core | grep 'YOUR PASSWORD'
 *
 * Compile with -DPERFORM_CLEANUP and try again.  (Don't forget to delete
 * the previous core file.)
 *
 */
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <string.h>
#include <sys/types.h>
#include <signal.h>

#define PASS_LEN  128

int main(int argc, char * argv[])
{
    char password[PASS_LEN];

    printf("Enter password:\n");
    system("stty -echo");
    fgets(password,PASS_LEN,stdin);
    system("stty echo");

    // ...
    // perform authentication or other magic with contents of password here
    // ...

#ifdef PERFORM_CLEANUP
    /* clean up! */
    fclose(stdin);               // drop system buffers
    memset(password,0,PASS_LEN); // clear out password storage memory
#endif

    // do lots of other things, possibly crashing, leaving a core
    // dump with password visible
    printf("Now crashing...\n");
    kill(getpid(),SIGSEGV);

    return 0;
}
