#!/bin/bash
# Copyright 2007-2009, Kees Cook <kees@outflux.net> License: GPLv3

TEMPFILE="/tmp/kees.$$"

# "Time of check"
if [ -f "$TEMPFILE" ]; then
    echo "Error: $TEMPFILE already exists" >&2
    exit 1
fi

# Bad person can "race" the touch and chmod, and open your $TEMPFILE
# before you change its permissions, and then read the contents later.
echo "Perform \"race\" here then hit enter to continue..."
read

# "Time of use"
touch "$TEMPFILE"
chmod og-rwx "$TEMPFILE"

echo "Super secret things" >> "$TEMPFILE"

echo "Examine $TEMPFILE then hit enter..."
read

rm -f "$TEMPFILE"
